<?php
defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.helper');

class plgJshoppingCheckoutAddon_extra_checkbox extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
	}
    
    function onBeforeDisplayCheckoutStep2View(&$view){
        $addon_config = $this->getAddonParams();
        if ($addon_config['extra_checkbox_text']){
            $view->_tmp_ext_html_address_end .= '<div class="extra_checkbox"> <input id="extra_checkbox" type = "checkbox" name = "extra_checkbox" value="1"/><label for="extra_checkbox">'.$addon_config['extra_checkbox_text'].'</label></div>';
        }
    }
    
    function onBeforeSaveCheckoutStep2(&$adv_user, &$user, &$cart){
        $extra_checkbox = JRequest::getInt('extra_checkbox');
		$addon_config = $this->getAddonParams();
        if ($extra_checkbox) {
            $session = JFactory::getSession();
            $session->set("extra_checkbox", "1");
        }
		if ($addon_config['required'] && !$extra_checkbox){
			JError::raiseWarning('', $addon_config['extra_checkbox_text']." "._JSHOP_REQUIRED);
			$app = JFactory::getApplication();			
			$app->redirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=2', 1));			
		}
    }

    function onBeforeDisplayCheckoutStep5View(&$view){
        $addon_config = $this->getAddonParams();
        JSFactory::loadExtLanguageFile('addon_extra_checkbox');
        if ($addon_config['confirm_delivery_email']){
            $text = sprintf(_JSHOP_CONFIRM_DELIVERY_EMAIL_TEXT, $view->sh_method->name, $view->sh_method->name);
            $view->_tmp_ext_html_previewfinish_agb .=
                '<div class="extra_checkbox"> '
              . '<input type="checkbox" name="confirm_delivery_email" id="confirm_delivery_email" value="1"> '
              . '<label for="confirm_delivery_email">'.$text.'</label>'
              . '</div>';
        }
    }

    function onBeforeCreateOrder(&$order, &$cart, &$model){
        $confirm_delivery_email = JRequest::getInt('confirm_delivery_email');
        $order->confirm_delivery_email = $confirm_delivery_email;
    }

	private function getAddonParams(){
		$addon = JTable::getInstance('addon', 'jshop');
        $addon->loadAlias('addon_extra_checkbox');
        return $addon->getParams();
	}
}